<?php
require_once("/usr/local/www/berogui/includes/Helper/Helper.php");

$exec_script = 1;
$invalid = array();

/* [CHECKING GET REQUEST] */
$list_get = array('m' => 'm', 'opt' => 'opt', 'start' => 'start', 'id' => 'id', 'gr' => 'group-name', 'name' => 'group-name', 'table' => 'select');

$options_get = array('table' => array('acl', 'dialplan', 'sms', 'whitelist', 'blacklist', 'callprogress', 'callprogress_entries', 'isdn', 'analog', 'gsm', 'lte', 'sip', 'cas', 'isgw_causes'));

$_GET = Helper::sanitizeGet($_GET, $list_get, $exec_script, $invalid, $options_get);

/* [CHECKING POST REQUEST] */
$list_post = array('gr' => 'group-name', 'ip' => 'ip4');

$_POST = Helper::sanitizePost($_POST, $list_post, $exec_script, $invalid);

/* [EXECUTING SCRIPT] */
switch ($_GET['table']) {
	case 'dialplan': $param = $_GET['m'] . '&start=' . $_GET['start'];
		break;
	case 'isdn': $param = $_GET['m'] . '&opt=' . strtolower($_GET['opt']);
		break;
	case 'analog': $param = $_GET['m'] . '&opt=' . strtolower($_GET['opt']);
		break;
	default: $param = $_GET['m'];
		break;
}

if (!$exec_script) {
	echo "<script>window.location='../../index.php?m=$param&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
	exit(1);
}

require_once "/usr/local/www/berogui/includes/isgwtelnet.php";


//this is treated different, because it doesn't access ari.db
//but works directly on isgw, so no yellow activate
if ($_GET['table'] == 'blacklist') {
	
		$param = $_GET['m'] ;
		$isgw = new isgwtelnet();
		$result = $isgw->isgw_login();
		$id = $_GET['id'];
		if ($id = "") {
			$isgw->isgw_blacklist_delete_all_entries ();
		}
		else {
			$blacklistresult = $isgw->isgw_blacklist_delete_entry_by_id ($id);
		}
		header('Location:/app/berogui/index.php?m=' . $param);
		return (0);
}

# check if session is valid
$newTarget = '/app/berogui/index.php?m=' . $param;
require_once('/usr/local/www/berogui/includes/session.php');
unset($newTarget);

// Einträge aus der Datenbank löschen

chdir("..");
include "./includes/variables.php";
require_once "./includes/Helper/Helper.php";
include_once("/usr/www/include/SQLite2ToSQLite3.php");
include './misc/database.php';

$ba = new beroAri();
if ($ba->is_error()) {
	die($ba->error());
}


$id = sqlite_escape_string($_GET['id']);
$table = sqlite_escape_string($_GET['table']);
if (isset($_POST['gr']) || isset($_POST['ip'])) {
	$query = $ba->delete("DELETE FROM sip WHERE name='" . sqlite_escape_string($_POST['gr']) . "-" . sqlite_escape_string($_POST['ip']) . "'");
	$query = $ba->select("SELECT isdnid FROM dialplan WHERE fromId='" . sqlite_escape_string($_POST['gr']) . "-" . sqlite_escape_string($_POST['ip']) . "'");
	while ($entry = $ba->fetch_array($query)) {
		if ($entry['isdnid'] != "")
			$query = $ba->delete("DELETE FROM dialplan WHERE isdnid='" . $entry['isdnid'] . "'");
	}
	$query = $ba->delete("DELETE FROM dialplan WHERE fromId='" . sqlite_escape_string($_POST['gr']) . "-" . sqlite_escape_string($_POST['ip']) . "'");
}

switch ($table) {
	case 'acl':
		$ba->set('acl_reload', 1);
		$query = $ba->delete("DELETE FROM $table WHERE id='$id'");
		break;
	case "isdn":
	case "analog":
	case "gsm":
	case "lte":
		$query = $ba->update("UPDATE $table SET gr='NULL', config='' WHERE gr='" . sqlite_escape_string($_GET['gr']) . "'");
		$query = $ba->delete("DELETE FROM dialplan where (fromId='g:" . sqlite_escape_string($_GET['gr']) . "' or toId='g:" . sqlite_escape_string($_GET['gr']) . "') and (fromDirection='$table' or toDirection='$table')");
		break;
	case "cas":
		$query = $ba->update("UPDATE cas_channels SET gr='NULL', config='' WHERE gr='" . sqlite_escape_string($_GET['gr']) . "'");
		$query = $ba->delete("DELETE FROM dialplan where (fromId='g:" . sqlite_escape_string($_GET['gr']) . "' or toId='g:" . sqlite_escape_string($_GET['gr']) . "') and (fromDirection='$table' or toDirection='$table')");
		break;
	case "sip":
		$query = $ba->delete("DELETE FROM dialplan where fromId='p:" . sqlite_escape_string($_GET['name']) . "' or toId='p:" . sqlite_escape_string($_GET['name']) . "' or fromId='d:" . sqlite_escape_string($_GET['name']) . "' or fromId='t:" . sqlite_escape_string($_GET['name']) . "' or fromId='a:" . sqlite_escape_string($_GET['name']) . "'");
		$query = $ba->delete("DELETE FROM " . $table . " WHERE id='$id'");
		break;
	case "callprogress":
		$query = $ba->delete("DELETE FROM callprogress_entries where id_name='$id';");
		$query = $ba->delete("DELETE FROM " . $table . " WHERE id='$id'");
		break;
	default:
		// TOASK - TODO - TOTEST: what is the default table ??
		$query = $ba->delete("DELETE FROM " . $table . " WHERE id='$id'");
		break;
}
if ($table == "isdn" || $table == "analog" || $table == "cas" || $table == "gsm" || $table == "lte" || $table == "isgw_causes") {
	Helper::activate(2);
}elseif (isset($_GET['table'])) {
	Helper::activate(1);
}


if ($ba->is_error()) {
	echo '<script>alert(' . $ba->error() . ');</script>';
	exit(0);
}

header('Location:/app/berogui/index.php?m=' . $param);
?>
